/* ### Standard Facilities ### */
new App.DomPassage("Pit", () => { return App.Facilities.Pit.pit(); }, ["jump-to-safe", "jump-from-safe"]);

new App.DomPassage("Incubator", () => { return App.UI.incubator(); }, ["jump-to-safe", "jump-from-safe"]);

/* ### Slave Interact Facilities ### */
new App.DomPassage("Wardrobe",
	() => {
		V.nextButton = "Back";
		V.nextLink = "Manage Penthouse";

		return App.UI.WardrobeShopping();
	}, ["jump-to-safe", "jump-from-safe"]
);

new App.DomPassage("Salon",
	() => {
		V.nextButton = "Confirm changes";
		V.nextLink = "Slave Interact";
		V.encyclopedia = "The Auto Salon";

		return App.UI.salon(getSlave(V.AS));
	}, ["jump-from-safe"]
);

new App.DomPassage("Body Modification",
	() => {
		V.nextButton = "Confirm changes";
		V.nextLink = "Slave Interact";
		V.encyclopedia = "The Studio";

		return App.UI.bodyModification(getSlave(V.AS));
	}, ["jump-from-safe"]
);

/* ### Special Facilities ### */
new App.DomPassage("Agent Select",
	() => {
		V.nextButton = "Back";
		V.nextLink = "Neighbor Interact";
		V.encyclopedia = "Agents";

		const f = document.createDocumentFragment();
		App.UI.DOM.appendNewElement("h2", f, "Appoint an Agent from your devoted slaves");

		// TODO Logic should not be handled here.
		f.append(App.UI.SlaveList.slaveSelectionList(
			s => s.fuckdoll === 0
				&& s.devotion > 20
				&& s.intelligence + s.intelligenceImplant > 15
				&& s.intelligenceImplant >= 15
				&& canWalk(s) && canSee(s) && canHear(s) && canTalk(s)
				&& s.broodmother < 2
				&& (s.breedingMark !== 1 || V.propOutcome === 0 || V.eugenicsFullControl === 1 || V.arcologies[0].FSRestart === "unset"),
			(slave) => App.UI.DOM.passageLink(SlaveFullName(slave), "Agent Workaround",
				() => { V.i = V.slaves.findIndex((s) => s.ID === slave.ID); }),
			s => App.Entity.facilities.arcologyAgent.manager.slaveHasExperience(s)
		));

		return f;
	}, ["jump-from-safe"]
);

new App.DomPassage("Rules Assistant",
	() => {
		const div = document.createElement("div");
		App.RA.options(div);
		return div;
	}, ["jump-to-safe", "jump-from-safe"]
);

new App.DomPassage("Toy Shop",
	() => {
		V.nextButton = "Back";
		V.nextLink = "Manage Penthouse";

		return App.UI.toyShop();
	},
);
