/**
 * UI for the Body Modification system/studio.  Refreshes without refreshing the passage.
 */
App.UI.toyShop = function() {
	const container = document.createElement("span");
	let buttPlugName = "";
	let buttPlugData = {
		name: "",
		width: 0,
		length: 0
	};

	container.append(createPage());
	return container;

	function createPage() {
		const el = new DocumentFragment();
		el.append(intro());
		el.append(buttPlugs());
		return el;
	}

	function intro() {
		const el = new DocumentFragment();
		App.UI.DOM.appendNewElement("h1", el, "Toy Shop");
		App.UI.DOM.appendNewElement("div", el, `The room is filled with the smell of rubber, latex, and various synthetic materials and solvents.  A series of screens allows you to design toys of various shapes and sizes, and then produce them at scale.  A bin of defects sits in the corner, glistening a bit under a layer of lubrication.`, "scene-intro");
		return el;
	}


	function buttPlugs() {
		const el = new DocumentFragment();
		let linkArray;
		App.UI.DOM.appendNewElement("h2", el, "Buttplugs");

		const value = App.UI.DOM.appendNewElement("div", el, `enter value here, "a butt plug"`);
		value.append(App.UI.DOM.makeTextBox(
			buttPlugName,
			v => {
				buttPlugName = v;
				refresh();
			}
		));

		const title = App.UI.DOM.appendNewElement("div", el, `enter value here, "Butt plug"`);
		title.append(App.UI.DOM.makeTextBox(
			buttPlugData.name,
			v => {
				buttPlugData.name = capFirstChar(v);
				refresh();
			}
		));


		const widthOptions = new Map([
			["standard", 1],
			["large", 2],
			["huge", 3],
		]);
		const width = App.UI.DOM.appendNewElement("div", el, `Select width`);
		linkArray = [];
		for (const [key, value] of widthOptions) {
			linkArray.push(
				App.UI.DOM.link(
					key,
					() => {
						buttPlugData.width = value;
						refresh();
					}
				)
			);
		}
		width.append(App.UI.DOM.generateLinksStrip(linkArray));

		// width

		// length
		const lengthOptions = new Map([
			["standard", 1],
			["long", 2],
		]);
		const length = App.UI.DOM.appendNewElement("div", el, `Select width`);
		linkArray = [];
		for (const [key, value] of lengthOptions) {
			linkArray.push(
				App.UI.DOM.link(
					key,
					() => {
						buttPlugData.length = value;
						refresh();
					}
				)
			);
		}
		length.append(App.UI.DOM.generateLinksStrip(linkArray));

		return el;

		function buildPlug() {

		}

		function deletePlug() {

		}
	}


	function refresh() {
		jQuery(container).empty().append(createPage());
	}
};
